local L = LibStub("AceLocale-3.0"):GetLocale("SliceCommander")

function SliceCommander:UNIT_HEALTH(_, unitID)
	if unitID == "player" then
		SliceCommander:HealthBar('HEALTH')
	elseif unitID == "target" then
		SliceCommander:HealthBar('THEALTH')
	end
end

function SliceCommander:PLAYER_REGEN_DISABLED()
	SliceCommander:HealthBar('HEALTH')
	SliceCommander:HealthBar('THEALTH')
	SliceCommander:TestDP()
	SliceCommander:Energy()
end

function SliceCommander:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, _, sourceName)
	if event == "SPELL_INTERRUPT" and sourceName == UnitName("player") and SC.SET.kickEnable == true then
		if SC.SET.kickChannel['INSTANCE_CHAT'] and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			SendChatMessage(SC.SET.kickMessage, 'INSTANCE_CHAT')
		elseif SC.SET.kickChannel['RAID'] and IsInRaid() then
			SendChatMessage(SC.SET.kickMessage, 'RAID')
		elseif SC.SET.kickChannel['PARTY'] and IsInGroup() then
			SendChatMessage(SC.SET.kickMessage, 'PARTY')
		elseif SC.SET.kickChannel['SAY'] then
			SendChatMessage(SC.SET.kickMessage, 'SAY')
		end
	end
end

function SliceCommander:UNIT_POWER_FREQUENT(_, unit, powerType)
	if unit == "player" and powerType == "COMBO_POINTS" then
		SliceCommander:TestDotPower(SC.BARS['RUP'])
		SliceCommander:SetComboPts()
		SliceCommander:ChangeAnchor()
	end
	if unit == "player" and powerType == "ENERGY" then
		SliceCommander:Energy()--energy value and play sound if necessary
	end
end

function SliceCommander:PLAYER_TARGET_CHANGED()
	SliceCommander:HealthBar('THEALTH')
	SliceCommander:ChangeAnchor()
end

function SliceCommander:UNIT_SPELLCAST_START(_, unit, spell)
	if unit == "player" and SC.SET.displayGCD then
		local start, dur = GetSpellCooldown(spell)
		if dur and dur > 0 and dur <= 1.5 then
			SC.OTHER['AS']['expire'] = start+dur
			SC.OTHER['AS']['obj']:SetMinMaxValues(0, dur)
			SC.OTHER['AS']['obj']:Show()
		end
	end
end

function SliceCommander:UNIT_MAXPOWER(_, UnitId, PowyerType)
	if SC.initDone and UnitId == "player" and PowyerType == "COMBO_POINTS" then
		--Update CP Bar
		local maxCP = UnitPowerMax("player", SPELL_POWER_COMBO_POINTS)

		for i = 1, maxCP do
			SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(unpack(SC.SET.CP[maxCP][i]))
		end
		for i = 1, 8 do
			SC.BARS['CP']['obj'].combos[i]:Hide()
		end

		SliceCommander:SetTimersHeight(SC.SET.TimerHeight)
		SliceCommander:SetWidth(SC.SET.Width)
		SliceCommander:SetComboPts()
	end
end

function SliceCommander:ACTIVE_TALENT_GROUP_CHANGED()
	if SC.initDone then
		SliceCommander:SetSparks()--MOVE SPARK for the current spec

		local aSpec = GetSpecialization()
		if aSpec == 1 then--POISONS
			local _, _, _, selected = GetTalentInfo(6, 1, 1)
			if SC.SET.poison.mh == SC_SPELL['AP'] and not selected then
				SC.OTHER['POISON']['obj'].button:SetAttribute("spell1", SC_SPELL['DP'])
			else
				SC.OTHER['POISON']['obj'].button:SetAttribute("spell1", SC.SET.poison.mh)
			end

			local _, _, _, selected = GetTalentInfo(4, 1, 1)
			if selected then
				SC.OTHER['POISON']['obj'].button:SetAttribute("spell2", SC.SET.poison.oh)
			else
				SC.OTHER['POISON']['obj'].button:SetAttribute("spell2", SC_SPELL['CRP'])
			end
		end
	end
end

function SliceCommander:PLAYER_LOGIN()
	SliceCommander:TestCurrentVersion()
	_G['SC'].initDone = true
	_G['SC'].order = 0
	_G['SC'].maxPos = 0
	_G['SC'].maxCDPos = 0
	SliceCommander_LoadTukuiApi()
	SliceCommander:TestValueOptions()
	SliceCommander:InitConfigurationTable()
	SliceCommander:InitFont()
	SliceCommander:InitConstantValue()
	SliceCommander:CreateCore()
	SliceCommander:InitBar()
	SliceCommander:InitIcon()
	SliceCommander:InitGCDBar()
	SliceCommander:ApplyConf()
	collectgarbage()
	UpdateAddOnMemoryUsage()
	print('|cffc14f2cSlice|r|cff40a740Commander|r v'..GetAddOnMetadata("SliceCommander", "Version")..' ('..L["memory use"]..':'..floor(GetAddOnMemoryUsage("SliceCommander"))..' kb)')
end

function SliceCommander:OnInitialize()
	if SC == nil then
		_G['SC'] = {}
	end
	_G['SC'].initDone = false
	local _, englishClass = UnitClass("player")
	if englishClass == "ROGUE" then
		--HAS TO BE Pixel Perfect scale
		local _, ScreenHeight = DecodeResolution(({GetScreenResolutions()})[GetCurrentResolution()] or GetCVar("gxWindowedResolution"))

		if ScreenHeight > 600 and _G['SC'] and _G['SC'].SET and _G['SC'].SET.PixelPerfect then
			SetCVar("uiScale", 768/ScreenHeight)
		end
		SliceCommander:RegisterEvent("PLAYER_REGEN_DISABLED")
		SliceCommander:RegisterEvent("PLAYER_REGEN_ENABLED", "PLAYER_REGEN_DISABLED")
		SliceCommander:RegisterEvent("UNIT_POWER_FREQUENT")
		SliceCommander:RegisterEvent("PLAYER_TARGET_CHANGED")
		SliceCommander:RegisterEvent("UNIT_HEALTH")
		SliceCommander:RegisterEvent("PLAYER_LOGIN")
		SliceCommander:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		SliceCommander:RegisterEvent("UNIT_SPELLCAST_START")
		SliceCommander:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED","UNIT_SPELLCAST_START")
		SliceCommander:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		SliceCommander:RegisterEvent("PLAYER_TALENT_UPDATE", "ACTIVE_TALENT_GROUP_CHANGED")
		SliceCommander:RegisterEvent("UNIT_MAXPOWER")
	else
		SliceCommander:OnDisable()
		return 0
	end
end